part of model_base;

@JsonSerializable()
class Day extends EditableModel with _$DaySerializerMixin {
  Day();

  factory Day.fromJson(Map<String, dynamic> json) => _$DayFromJson(json);

  void init(DateTime start) {
    start_time = new DateTime(
        start.year, start.month, start.day, startHour, startMinute);
    end_time =
        new DateTime(start.year, start.month, start.day, endHour, endMinute);

    var iTime = start_time;
    while (iTime.isBefore(end_time)) {
      increments.add(new Increment(iTime));
      iTime = iTime.add(Increment.duration);
    }
  }

  bool isPopulated(String salonId, String userId) {
    if (id == null || salon_id != salonId)
      return false;
    else if (userId == null)
      return increments.where((i) => i.user_states.isNotEmpty).isNotEmpty;
    else
      return increments
          .where((i) => i.user_states.containsKey(userId))
          .isNotEmpty;
  }

  bool hasBookings(String user_id) {
    if (user_id == null) return false;

    return increments.firstWhere(
            (i) =>
                i.user_states.containsKey(user_id) &&
                i.user_states[user_id].booking_id != null,
            orElse: () => null) !=
        null;
  }

  @JsonKey(nullable: false)
  List<Increment> increments = [];

  DateTime start_time;
  DateTime end_time;
  String salon_id;

  static const int startHour = 8;
  static const int startMinute = 0;
  static const int endHour = 20;
  static const int endMinute = 0;
}
