part of model_base;

@JsonSerializable()
class Increment extends Object with _$IncrementSerializerMixin {
  Increment(this.start_time) : end_time = start_time.add(duration);

  factory Increment.fromJson(Map<String, dynamic> json) =>
      _$IncrementFromJson(json);

  static const Duration duration = const Duration(minutes: 10);
  final DateTime start_time;
  final DateTime end_time;

  @JsonKey(nullable: false)
  Map<String, UserState> user_states = {};

  bool get isPopulated =>
      user_states.values
          .firstWhere((us) => us.state != null, orElse: () => null) !=
      null;
}

@JsonSerializable()
class UserState extends Object with _$UserStateSerializerMixin {
  UserState(this.user_id) {
    booking_id = null;
    state = null;
  }

  factory UserState.fromJson(Map<String, dynamic> json) =>
      _$UserStateFromJson(json);

  final String user_id;
  String booking_id;
  String state;
}