part of model_base;

@JsonSerializable()
class Customer extends EditableModel with _$CustomerSerializerMixin {
  Customer() {
    final rnd = new Random.secure();
    final codeUnits = <int>[];
    for (var i = 0; i < 6; i++) {
      codeUnits.add(rnd.nextInt(30) + 97);
    }
    password = new String.fromCharCodes(codeUnits);
  }

  factory Customer.fromJson(Map<String, dynamic> json) =>
      _$CustomerFromJson(json);

  String toString() => email;
  void operator []=(String key, Object value) {
    switch (key) {

      case 'care_of':
        care_of = value;
        break;

      case 'comments_external':
        comments_external = value;
        break;

      case 'comments_internal':
        comments_internal = value;
        break;

      case 'city':
        city = value;
        break;

      case 'country':
        country = value;
        break;

      case 'email':
        email = value;
        break;

      case 'email_shop':
        email_shop = value;
        break;

      case 'firstname':
        firstname = value;
        break;

      case 'lastname':
        lastname = value;
        break;

      case 'phone':
        phone = value;
        break;

      case 'postal_code':
        postal_code = value;
        break;

      case 'language':
        language = value;
        break;

      case 'social_number':
        social_number = value;
        break;

      case 'street':
        street = value;
        break;

      case 'password':
        password = value;
        break;

      case 'red_flagged':
        red_flagged = value;
        break;

      case 'after_image_url':
        after_image_url = value;
        break;

      case 'before_image_url':
        before_image_url = value;
        break;

      case 'created':
        created = value;
        break;

      case 'status':
        status = value;
        break;

      case 'added_by':
        added_by = value;
        break;

      case 'user_id':
        user_id = value;
        break;

      default:
        break;
    }
  }

  String care_of;
  String comments_external;
  String comments_internal;
  String city;
  String country = '1';
  String email;
  String email_shop;
  String firstname;
  String lastname;
  String phone;
  String postal_code;
  String language = '1';
  String social_number;
  String street;
  String password;

  bool red_flagged = false;

  /// Temp for importing
  String after_image_url;
  String before_image_url;

  @JsonKey(nullable: false)
  String user_id;
}
