part of model_base;

@JsonSerializable()
class Product extends EditableModel with _$ProductSerializerMixin {
  Product();

  factory Product.fromJson(Map<String, dynamic> json) =>
      _$ProductFromJson(json);

  @override
  String toString() => '$name ($volume ml)';

  String name;
  String article_no;
  int buy_price_sek;
  String image_uri;
  num price_eur = 0;
  num price_sek = 0;
  num price_usd = 0;
  int search_rank;
  int score;
  int stock;
  String type = 'standard';
  String url_name;
  int vat = 25;
  int volume;
  int weight;

  @JsonKey(nullable: false)
  List<String> related_product_ids = [];

  @JsonKey(nullable: false)
  List<String> sub_product_ids = [];

  @JsonKey(nullable: false)
  List<String> ingredient_ids = [];
}

@JsonSerializable()
class ProductPhrases extends Object with _$ProductPhrasesSerializerMixin {
  ProductPhrases();

  factory ProductPhrases.fromJson(Map<String, dynamic> json) =>
      _$ProductPhrasesFromJson(json);

  String name;
  String description_long;
  String description_short;
  String usage_instructions;
  String meta_description;
  String meta_keywords;
}
