part of model_base;

@JsonSerializable()
class ProductRoutine extends EditableModel
    with _$ProductRoutineSerializerMixin {
  ProductRoutine();

  factory ProductRoutine.fromJson(Map<String, dynamic> json) =>
      _$ProductRoutineFromJson(json);

  @override
  String toString() => name;

  String name;
  String state = 'daily';
  String daily_routine_morning;
  String daily_routine_mid_day;
  String daily_routine_evening;
  String weekly_routine;
  int day_step = 1;

  @JsonKey(nullable: false)
  List<Map<String, dynamic>> startup_days =
      new List.generate(29, (i) => new StartupDay().toJson());
}

@JsonSerializable()
class StartupDay extends Object with _$StartupDaySerializerMixin {
  StartupDay();

  factory StartupDay.fromJson(Map<String, dynamic> json) =>
      _$StartupDayFromJson(json);

  bool active = false;
  bool night;
  int duration_minutes;
}
