import 'dart:async' show Future;
import 'package:angular/angular.dart' show Injectable;
import '../api.bokain.se/restful_service_base.dart';

@Injectable()
class MailerService extends RestfulServiceBase {
  MailerService() : super();

  Future<String> mail(String body, String subject, String to) async =>
      await httpPOST('mail', {'body': body, 'subject': subject, 'to': to});

  String formatHM(DateTime date) {
    final hour = (date.hour < 10) ? '0${date.hour}' : date.hour.toString();
    final minute =
        (date.minute < 10) ? '0${date.minute}' : date.minute.toString();
    return '$hour:$minute';
  }
}
