part of firestore_service;

@Injectable()
class ConsultationService extends FirestoreService<Consultation> {
  ConsultationService();

  @override
  Consultation createModelInstance(Map<String, dynamic> data) =>
      new Consultation.fromJson(data);

  Future<String> uploadImage(String name, String base64) async {
    try {
      _loading = true;
      final parts = base64.split(';base64,');
      final contentType = parts.first.substring('data:'.length);
      final data = parts.last;

      final filename = Uri.encodeFull(name);
      final metadata = new fb.UploadMetadata(contentType: contentType);
      final snapshot = await _imagesRef
          .child(filename)
          .putString(data, 'base64', metadata)
          .future;
      return snapshot.downloadURL.toString();
    } on Exception {
      return null;
    } finally {
      _loading = false;
    }
  }

  final fb.StorageReference _imagesRef =
      fb.storage().ref('consultation-images');
}
