part of firestore_service;

@Injectable()
class CustomerService extends FirestoreService<Customer> {
  CustomerService() : super('customers', ['email', 'social_number']);

  @override
  Customer createModelInstance(Map<String, dynamic> data) =>
      data == null ? new Customer() : new Customer.fromJson(data);

  Future<Map<Object, dynamic>> fetchDetails(String social_number) async {
    _loading = true;

    try {
      final response = await dom.HttpRequest
          .getString('https://api.bokain.se/index.php/ssn/$social_number');
      return json.decode(response);
    } finally {
      _loading = false;
    }
  }
}
