part of firestore_service;

@Injectable()
class DayService extends FirestoreService<Day> {
  DayService() : super('days');

  @override
  Day createModelInstance(Map<String, dynamic> data) =>
      data == null ? new Day() : new Day.fromJson(data);

  Iterable<Increment> getIncrementRangeOf(
      Day day, DateTime range_start, DateTime range_end) {
    final start = range_start.add(const Duration(minutes: -1));
    final end = range_end.add(const Duration(minutes: 1));
    return day.increments
        .where((i) => i.start_time.isAfter(start) && i.end_time.isBefore(end));
  }
}
