part of firestore_service;

@Injectable()
class JournalService extends FirestoreService<JournalEntry> {
  JournalService() : super('journal');

  @override
  JournalEntry createModelInstance(Map<String, dynamic> data) =>
      new JournalEntry.fromJson(data);

  Future<String> uploadImage(String base64) async {
    try {
      _loading = true;
      final parts = base64.split(';base64,');
      final contentType = parts.first.substring('data:'.length);
      final data = parts.last;

      final filename =
          Uri.encodeFull(new DateTime.now().millisecondsSinceEpoch.toString());
      final metadata = new fb.UploadMetadata(contentType: contentType);
      await _imagesRef
          .child(filename)
          .putString(data, 'base64', metadata)
          .future;
      return (await _imagesRef.child(filename).getDownloadURL()).toString();
    } on Exception {
      return null;
    } finally {
      _loading = false;
    }
  }

  final fb.StorageReference _imagesRef = fb.storage().ref('journal-images');
}
