part of firestore_service;

@Injectable()
class ProductCategoryService extends FirestoreService<ProductCategory> {
  ProductCategoryService() : super('product_categories', ['name']);

  @override
  ProductCategory createModelInstance(Map<String, dynamic> data) =>
      data == null ? new ProductCategory() : new ProductCategory.fromJson(data);

  Future<String> uploadImage(String article_no, String base64) async {
    try {
      _loading = true;
      final parts = base64.split(';base64,');
      final contentType = parts.first.substring('data:'.length);
      final data = parts.last;

      final filename = Uri.encodeFull(article_no);
      final metadata = new fb.UploadMetadata(contentType: contentType);
      await _imagesRef
          .child(filename)
          .putString(data, 'base64', metadata)
          .future;
      return (await _imagesRef.child(filename).getDownloadURL()).toString();
    } on Exception {
      return null;
    } finally {
      _loading = false;
    }
  }

  final fb.StorageReference _imagesRef =
      fb.storage().ref('product-category-images');
}
