part of firestore_service;

@Injectable()
class ProductService extends FirestoreService<Product> {
  ProductService() : super('products', ['name', 'article_no']);

  @override
  Product createModelInstance(Map<String, dynamic> data) =>
      data == null ? new Product() : new Product.fromJson(data);

  Future<String> uploadImage(String article_no, String base64) async {
    try {
      _loading = true;
      final parts = base64.split(';base64,');
      final contentType = parts.first.substring('data:'.length);
      final data = parts.last;

      final filename = Uri.encodeFull(article_no);
      final metadata = new fb.UploadMetadata(contentType: contentType);
      await _imagesRef
          .child(filename)
          .putString(data, 'base64', metadata)
          .future;
      return (await _imagesRef.child(filename).getDownloadURL()).toString();
    } on Exception {
      return null;
    } finally {
      _loading = false;
    }
  }

  final fb.StorageReference _imagesRef = fb.storage().ref('product-images');
}
