part of firestore_service;

@Injectable()
class SalonService extends FirestoreService<Salon> {
  SalonService() : super('salons', ['name']);

  @override
  Salon createModelInstance(Map<String, dynamic> data) =>
      data == null ? new Salon() : new Salon.fromJson(data);

  Future<String> uploadImage(
      String salon_name, String company_name, String base64) async {
    try {
      _loading = true;
      final parts = base64.split(';base64,');
      final contentType = parts.first.substring('data:'.length);
      final data = parts.last;

      final filename = Uri.encodeFull('${salon_name}_$company_name');
      final metadata = new fb.UploadMetadata(contentType: contentType);
      await _logosRef
          .child(filename)
          .putString(data, 'base64', metadata)
          .future;
      return (await _logosRef.child(filename).getDownloadURL()).toString();
    } on Exception {
      return null;
    } finally {
      _loading = false;
    }
  }

  final fb.StorageReference _logosRef = fb.storage().ref('salon-logos');
}
