import 'dart:async';
import 'package:angular/di.dart';
import 'package:firebase/firebase.dart' as fb;
import 'package:firebase/firestore.dart' as fs;

@Injectable()
class PhrasesService {
  PhrasesService() {
    _collection = fb.firestore().collection('phrase_data');
  }

  Future<Map<String, Map<String, Object>>> fetchAll(String language) async {
    final response = await _collection.get();
    final output = <String, Map<String, Object>>{};
    for (final doc in response.docs) {
      output[doc.id] = doc.data();
    }
    return output;
  }

  Future update(String key, Map<String, String> value) async {
    await _collection.doc(key).set(value);
  }
  
  fs.CollectionReference _collection;

}
