import 'package:angular/di.dart';
import '../../static_model/skin_type.dart';

@Injectable()
class SkinTypeService {
  SkinType get(String id) => _data.containsKey(id) ? _data[id] : null;

  Map<String, SkinType> get data => _data;

  final Map<String, SkinType> _data = {
    '1': new SkinType()
      ..id = '1'
      ..label = 'acne'
      ..symptomRegistry = [
        new SymptomMap(
                open_comedones: 0,
                closed_comedones: 0,
                papules: 1,
                seborrhea: 0,
                rosacea: 0)
            .toJson(),
        new SymptomMap(papules: 2, seborrhea: 0, rosacea: 0).toJson(),
        new SymptomMap(papules: 2, seborrhea: 1, rosacea: 0).toJson(),
        new SymptomMap(papules: 3, rosacea: 0).toJson(),
        new SymptomMap(pustules: 1, rosacea: 0).toJson(),
        new SymptomMap(pustules: 2, rosacea: 0).toJson(),
        new SymptomMap(pustules: 3, rosacea: 0).toJson(),
        new SymptomMap(cysts: 1, rosacea: 0).toJson(),
        new SymptomMap(cysts: 2, rosacea: 0).toJson(),
        new SymptomMap(cysts: 3, rosacea: 0).toJson(),
        new SymptomMap(nodules: 1, rosacea: 0).toJson(),
        new SymptomMap(nodules: 2, rosacea: 0).toJson(),
        new SymptomMap(nodules: 3, rosacea: 0).toJson()
      ],
    '2': new SkinType()
      ..id = '2'
      ..label = 'combination_skin'
      ..symptomRegistry = [],
    '3': new SkinType()
      ..id = '3'
      ..label = 'oily'
      ..symptomRegistry = [
        new SymptomMap(
                open_comedones: 0,
                closed_comedones: 0,
                papules: 0,
                pustules: 0,
                cysts: 0,
                nodules: 0,
                seborrhea: 0,
                rosacea: 0,
                milia: false,
                surface_blood_vessels: false,
                acne_scars: false,
                texture: 'oily')
            .toJson()
      ],
    '4': new SkinType()
      ..id = '4'
      ..label = 'milia'
      ..symptomRegistry = [
        new SymptomMap(
                open_comedones: 0,
                closed_comedones: 0,
                papules: 0,
                cysts: 0,
                nodules: 0,
                seborrhea: 0,
                rosacea: 0,
                milia: true,
                pigmentation: false,
                surface_blood_vessels: false,
                acne_scars: false)
            .toJson()
      ],
    '5': new SkinType()
      ..id = '5'
      ..label = 'pigmentation'
      ..symptomRegistry = [
        new SymptomMap(
                open_comedones: 0,
                closed_comedones: 0,
                papules: 0,
                cysts: 0,
                nodules: 0,
                seborrhea: 0,
                rosacea: 0,
                milia: false,
                pigmentation: true,
                surface_blood_vessels: false,
                acne_scars: false)
            .toJson()
      ],
    '6': new SkinType()
      ..id = '6'
      ..label = 'comedones'
      ..symptomRegistry = [
        new SymptomMap(
                closed_comedones: 2,
                papules: 0,
                pustules: 0,
                cysts: 0,
                nodules: 0,
                seborrhea: 1,
                rosacea: 0)
            .toJson(),
        new SymptomMap(
                closed_comedones: 3,
                papules: 0,
                pustules: 0,
                cysts: 0,
                nodules: 0,
                seborrhea: 1,
                rosacea: 0)
            .toJson(),
        new SymptomMap(
                open_comedones: 2,
                papules: 0,
                pustules: 0,
                cysts: 0,
                nodules: 0,
                seborrhea: 1,
                rosacea: 0)
            .toJson(),
        new SymptomMap(
                open_comedones: 3,
                papules: 0,
                pustules: 0,
                cysts: 0,
                nodules: 0,
                seborrhea: 1,
                rosacea: 0)
            .toJson(),
        new SymptomMap(
                open_comedones: 1,
                papules: 0,
                pustules: 0,
                cysts: 0,
                nodules: 0,
                seborrhea: 0,
                rosacea: 0)
            .toJson(),
        new SymptomMap(
                open_comedones: 2,
                papules: 0,
                pustules: 0,
                cysts: 0,
                nodules: 0,
                seborrhea: 0,
                rosacea: 0)
            .toJson(),
        new SymptomMap(
                open_comedones: 3,
                papules: 0,
                pustules: 0,
                cysts: 0,
                nodules: 0,
                seborrhea: 0,
                rosacea: 0)
            .toJson(),
        new SymptomMap(
                closed_comedones: 1,
                papules: 0,
                pustules: 0,
                cysts: 0,
                nodules: 0,
                seborrhea: 0,
                rosacea: 0)
            .toJson(),
        new SymptomMap(
                closed_comedones: 2,
                papules: 0,
                pustules: 0,
                cysts: 0,
                nodules: 0,
                seborrhea: 0,
                rosacea: 0)
            .toJson(),
        new SymptomMap(
                closed_comedones: 3,
                papules: 0,
                pustules: 0,
                cysts: 0,
                nodules: 0,
                seborrhea: 0,
                rosacea: 0)
            .toJson(),
        new SymptomMap(
                closed_comedones: 2,
                papules: 1,
                pustules: 0,
                cysts: 0,
                nodules: 0,
                seborrhea: 0,
                rosacea: 0)
            .toJson(),
        new SymptomMap(
                closed_comedones: 3,
                papules: 1,
                pustules: 0,
                cysts: 0,
                nodules: 0,
                seborrhea: 0,
                rosacea: 0)
            .toJson(),
        new SymptomMap(
                closed_comedones: 2,
                papules: 1,
                pustules: 0,
                cysts: 0,
                nodules: 0,
                seborrhea: 1,
                rosacea: 0)
            .toJson(),
        new SymptomMap(
                closed_comedones: 3,
                papules: 1,
                pustules: 0,
                cysts: 0,
                nodules: 0,
                seborrhea: 2,
                rosacea: 0)
            .toJson(),
        new SymptomMap(
                open_comedones: 1,
                papules: 0,
                pustules: 0,
                cysts: 0,
                nodules: 0,
                seborrhea: 0,
                rosacea: 0)
            .toJson(),
        new SymptomMap(
                open_comedones: 2,
                papules: 1,
                pustules: 0,
                cysts: 0,
                nodules: 0,
                seborrhea: 0,
                rosacea: 0)
            .toJson(),
        new SymptomMap(
                open_comedones: 3,
                papules: 1,
                pustules: 0,
                cysts: 0,
                nodules: 0,
                seborrhea: 0,
                rosacea: 0)
            .toJson(),
        new SymptomMap(
                open_comedones: 2,
                papules: 1,
                pustules: 0,
                cysts: 0,
                nodules: 0,
                seborrhea: 1,
                rosacea: 0)
            .toJson(),
        new SymptomMap(
                open_comedones: 3,
                papules: 1,
                pustules: 0,
                cysts: 0,
                nodules: 0,
                seborrhea: 1,
                rosacea: 0)
            .toJson(),
        new SymptomMap(
                open_comedones: 3,
                papules: 1,
                pustules: 0,
                cysts: 0,
                nodules: 0,
                seborrhea: 2,
                rosacea: 0)
            .toJson(),
      ],
    '7': new SkinType()
      ..id = '7'
      ..label = 'rosacea'
      ..symptomRegistry = [
        new SymptomMap(rosacea: 1).toJson(),
        new SymptomMap(rosacea: 2).toJson(),
        new SymptomMap(rosacea: 3).toJson()
      ],
    '8': new SkinType()
      ..id = '8'
      ..label = 'seborrhea'
      ..symptomRegistry = [
        new SymptomMap(
                open_comedones: 0,
                closed_comedones: 0,
                papules: 0,
                pustules: 0,
                cysts: 0,
                nodules: 0,
                seborrhea: 1,
                rosacea: 0,
                pigmentation: false,
                surface_blood_vessels: false,
                acne_scars: false)
            .toJson(),
        new SymptomMap(
                open_comedones: 0,
                closed_comedones: 0,
                papules: 0,
                pustules: 0,
                cysts: 0,
                nodules: 0,
                seborrhea: 2,
                rosacea: 0,
                pigmentation: false,
                surface_blood_vessels: false,
                acne_scars: false)
            .toJson(),
        new SymptomMap(
                open_comedones: 0,
                closed_comedones: 0,
                papules: 0,
                pustules: 0,
                cysts: 0,
                nodules: 0,
                seborrhea: 3,
                rosacea: 0,
                pigmentation: false,
                surface_blood_vessels: false,
                acne_scars: false)
            .toJson(),
      ],
    '9': new SkinType()
      ..id = '9'
      ..label = 'dry'
      ..symptomRegistry = [
        new SymptomMap(
                open_comedones: 0,
                closed_comedones: 0,
                papules: 0,
                pustules: 0,
                cysts: 0,
                nodules: 0,
                seborrhea: 0,
                rosacea: 0,
                pigmentation: false,
                surface_blood_vessels: false,
                acne_scars: false,
                texture: 'dry')
            .toJson()
      ],
    '10': new SkinType()
      ..id = '10'
      ..label = 'surface_blood_vessels'
      ..symptomRegistry = [
        new SymptomMap(
                open_comedones: 0,
                closed_comedones: 0,
                papules: 0,
                pustules: 0,
                cysts: 0,
                nodules: 0,
                seborrhea: 0,
                rosacea: 0,
                milia: false,
                pigmentation: false,
                surface_blood_vessels: true,
                acne_scars: false)
            .toJson()
      ],
    '11': new SkinType()
      ..id = '11'
      ..label = 'acne_scars'
      ..symptomRegistry = [
        new SymptomMap(
                open_comedones: 0,
                closed_comedones: 0,
                papules: 0,
                pustules: 0,
                cysts: 0,
                nodules: 0,
                seborrhea: 0,
                rosacea: 0,
                milia: false,
                pigmentation: false,
                surface_blood_vessels: false,
                acne_scars: true)
            .toJson()
      ]
  };

  final Map<String, int> symptomScoreRegistry = {
    'open_comedones': 1,
    'closed_comedones': 1,
    'papules': 2,
    'pustules': 3,
    'cysts': 5,
    'nodules': 5,
    'texture_dry': -1,
    'texture_oily': 1
  };
}
