library skin_type;

import 'package:json_annotation/json_annotation.dart';

part 'skin_type.g.dart';

@JsonSerializable()
class SkinType extends Object with _$SkinTypeSerializerMixin {
  SkinType();

  String id;
  String label;

  @JsonKey(nullable: false)
  List<Map<String, dynamic>> symptomRegistry = [];

  @override
  String toString() => label;
}

@JsonSerializable()
class SymptomMap extends Object with _$SymptomMapSerializerMixin {
  SymptomMap(
      {this.open_comedones,
      this.closed_comedones,
      this.papules,
      this.pustules,
      this.cysts,
      this.nodules,
      this.seborrhea,
      this.rosacea,
      this.milia,
      this.pigmentation,
      this.surface_blood_vessels,
      this.acne_scars,
      this.texture});

  factory SymptomMap.fromJson(Map<String, dynamic> json) =>
      _$SymptomMapFromJson(json);

  bool partialMatch(SymptomMap other) {
    final firstEncoded = toJson();
    final secondEncoded = other.toJson();
    final matches = firstEncoded.keys.where((key) =>
        firstEncoded[key] == null ||
        secondEncoded[key] == null ||
        firstEncoded[key] == secondEncoded[key]);
    return matches.length == firstEncoded.length;
  }

  String id;
  int open_comedones;
  int closed_comedones;
  int papules;
  int pustules;
  int cysts;
  int nodules;
  int seborrhea;
  int rosacea;
  bool milia;
  bool pigmentation;
  bool surface_blood_vessels;
  bool acne_scars;
  String texture;
}
